/***************************************************************************
                          krecfilewidgets.h  -  description
                             -------------------
    copyright            : (C) 2003 by Arnold Krille
    email                : arnold@arnoldarts.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License.               *
 *                                                                         *
 ***************************************************************************/

#ifndef KRECFILEWIDGETS_H
#define KRECFILEWIDGETS_H

#include <qframe.h>
#include <qptrlist.h>
#include <qpoint.h>

class KRecFile;
class KRecBuffer;
class TimeDisplay;
class QBoxLayout;
class QLabel;
class QLineEdit;

class KRecFileWidget;
class KRecBufferWidget;
class KRecTimeBar;
class KRecTimeDisplay;

class QRegion;
class QPainter;
class KAction;
class KToggleAction;

class KRecFileWidget : public QFrame {
   Q_OBJECT
public:
	KRecFileWidget( KRecFile*, QWidget*, const char* =0 );
	~KRecFileWidget();

	void setFile( KRecFile* );

	void resizeEvent( QResizeEvent* =0 );
	void mouseReleaseEvent( QMouseEvent* );
public slots:
	void newBuffer( KRecBuffer* );
	void deleteBuffer( KRecBuffer* );
private:
	KRecFile *_file;
	QPtrList<KRecBufferWidget> bufferwidgets;
};

class KRecBufferWidget : public QFrame {
   Q_OBJECT
public:
	KRecBufferWidget( KRecBuffer*, QWidget*, const char* =0 );
	~KRecBufferWidget();

	const KRecBuffer* buffer() { return _buffer; }

	void resizeEvent( QResizeEvent* );

	void drawFrame( QPainter* );
	void drawContents( QPainter* );
	void paintEvent( QPaintEvent* );

	void mousePressEvent( QMouseEvent* );
private:
	KRecBuffer *_buffer;
	KAction *_removeaction;
	KToggleAction *_activeaction;
	QRegion *_main_region, *_title_region, *_fileend_region;
	QPoint _topleft, _bottomleft, _bottomright, _topright, _topmiddle, _bottommiddle;
	int _title_height;
};

#endif

// vim:sw=4:ts=4
